unit Unit2;
interface
uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, Edinburgh_TLB, StdVcl, Provider, Db, DBTables;

type
  TDrBob42 = class(TRemoteDataModule, IDrBob42)
    Table1: TTable;
    CustomerOrdersProvider: TDataSetProvider;
    Query1: TQuery;
    CommandTextProvider: TDataSetProvider;
    TableOrders: TTable;
    DataSource1: TDataSource;
    Table1CustNo: TFloatField;
    Table1Company: TStringField;
    Table1City: TStringField;
    Table1LastInvoiceDate: TDateTimeField;
    Session1: TSession;
    procedure CustomerOrdersProviderBeforeGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
    procedure CustomerOrdersProviderAfterGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

class procedure TDrBob42.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
    RegisterPooled(ClassID, 1, 1);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    UnRegisterPooled(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

procedure TDrBob42.CustomerOrdersProviderBeforeGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
var
  Str: String;
begin
{
  Str := OwnerData;
  if Str <> '' then
  try
    if (Sender AS TDataSetProvider).
      DataSet.Locate('CustNo',Str,[]) then
      (Sender AS TDataSetProvider).
        DataSet.Next
  except
    // eating all exceptions...
  end
}
end;

procedure TDrBob42.CustomerOrdersProviderAfterGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
var
  DSP: TDataSetProvider;
begin
  DSP := (Sender AS TDataSetProvider);
  if DSP.DataSet.Active then
  begin
    OwnerData :=
      Format('%d number of records',
        [DSP.DAtaSet.RecordCOunt]);
  end
  else
    OwnerData := 'DataSet is closed';
end;

initialization
//  TCorbaVclComponentFactory.Create('DrBob42Factory', 'DrBob42',
//    'IDL:Edinburgh/DrBob42Factory:1.0', IDrBob42, TDrBob42, iMultiInstance,
//    tmSingleThread);
  TComponentFactory.Create(ComServer, TDrBob42,
    Class_DrBob42, ciMultiInstance, tmApartment);
end.
